      PROGRAM REAC
      LOGICAL EX
      CHARACTER*1 YN
      CHARACTER*3 STAT
      CHARACTER*4 NA(20)
      CHARACTER*12 FN
      CHARACTER*24 RE(40)
      DIMENSION NT(40)
      ITERI = 5
      ITERO = 6
      WRITE(ITERO,1000)
110   WRITE(ITERO,1010)
      READ(ITERI,1020,ERR=110) NSPEC
      IF (NSPEC.EQ.0) STOP
      IF ((NSPEC.GT.0).AND.(NSPEC.LE.20)) GOTO 120
      WRITE(ITERO,1030)
      GOTO 110
1000  FORMAT('0','Program To Create A REAC File')
1010  FORMAT('0','Input number of species (20 max): ')
1020  FORMAT(I2)
1030  FORMAT(' ','INVALDID NUMBER')
120   WRITE(ITERO,1040)
      WRITE(ITERO,1050)
      DO 130 I = 1, NSPEC
230   WRITE(ITERO,1060) I
      READ(ITERI,1070,ERR=230) NA(I)
130   CONTINUE
1040  FORMAT(' ','Input species (in capitals)')
1050  FORMAT(' ')
1060  FORMAT(' ','Species #',I2,': ')
1070  FORMAT(A4)
      WRITE(ITERO,1080)
140   WRITE(ITERO,1090)
      READ(ITERI,1100,ERR=140) NREAC
      IF (NREAC.EQ.0) STOP
      IF ((NREAC.GT.0).AND.(NREAC.LE.40)) GOTO 150
      WRITE(ITERO,1110)
      GOTO 140
1080  FORMAT(' ')
1090  FORMAT(' ','Input number of reactions (40 max): ')
1100  FORMAT(I3)
1110  FORMAT(' ','INVALID NUMBER')
150   WRITE(ITERO,1120)
      WRITE(ITERO,1130)
      WRITE(ITERO,1140)
      WRITE(ITERO,1150)
      WRITE(ITERO,1160)
      WRITE(ITERO,1170)
      WRITE(ITERO,1180)
      WRITE(ITERO,1190)
      WRITE(ITERO,1200)
      WRITE(ITERO,1210)
1120  FORMAT(' ')
1130  FORMAT(' ','Input reactions in the following format:')
1140  FORMAT(' ','    type of rxt            rxt format')
1150  FORMAT(' ','        1             aaaa+bbbb=cccc+dddd')
1160  FORMAT(' ','        2             aaaa+M=cccc+dddd+M')
1170  FORMAT(' ','        3             aaaa+bbbb+M=cccc+M')
1180  FORMAT(' ','        4             aaaa+bbbb=cccc+dddd+eeee')
1190  FORMAT(' ','        5             aaaa+M=bbbb+M')
1200  FORMAT(' ','        6             aaaa=bbbb+h*nu')
1210  FORMAT(' ')
      DO 180 I = 1, NREAC
160   WRITE(ITERO,1220) I
      READ(ITERI,1230,ERR=160) NT(I)
      IF (NT(I).EQ.0) STOP
      IF ((NT(I).GT.0).AND.(NT(I).LE.6)) GOTO 170
      WRITE(ITERO,1240)
      GOTO 160
1220  FORMAT(' ','Reaction #',I3,' type: ')
1230  FORMAT(I1)
1240  FORMAT(' ','INVALID NUMBER')
170   WRITE(ITERO,1250) I
      READ(ITERI,1260,ERR=170) RE(I)
      IF (RE(I).EQ.' ') STOP
180   CONTINUE
1250  FORMAT(' ','Reaction #',I2,': ')
1260  FORMAT(A24)
      WRITE(ITERO,1270)
240   WRITE(ITERO,1280)
      READ(ITERI,1290,ERR=240) YN
      IF ((YN.EQ.'Y').OR.(YN.EQ.'y')) GOTO 190
250   WRITE(ITERO,1300)
      READ(ITERI,1310,ERR=250) FN
      GOTO 200
190   FN = 'REAC.INP'
200   WRITE(ITERO,1320)
      WRITE(ITERO,1330)
1270  FORMAT(' ')
1280  FORMAT(' ','Ok to save system in file REAC.INP (Y/N): ')
1290  FORMAT(A1)
1300  FORMAT(' ','Input file name to use: ')
1310  FORMAT(A12)
1320  FORMAT(' ')
1330  FORMAT(' ','SAVING SYSTEM')
      NU = 10
      OPEN(NU,FILE = FN,STATUS = 'UNKNOWN')
      WRITE(NU,1340) NSPEC,NREAC
      DO 210 I = 1, NSPEC
      WRITE(NU,1350) NA(I)
210   CONTINUE
      DO 220 I = 1,NREAC
      WRITE(NU,1360) NT(I)
      WRITE(NU,1370) RE(I)
220   CONTINUE
      CLOSE(NU,STATUS = 'KEEP')
1340  FORMAT(I2,',',I2)
1350  FORMAT(A4)
1360  FORMAT(I1)
1370  FORMAT(A24)
      STOP
      END
